<?php
/**
 * @package SJ Cool Showcase for SobiPro
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2014 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */


defined('_JEXEC') or die;

require_once dirname( __FILE__ ).'/sjspdefine.php'; 

if (!class_exists('JFormFieldSjSpCategories')){
	class JFormFieldSjSpCategories extends JFormField {
	
		protected $type = 'SjSpCategories';
		
		protected function getInput(){
			$file_config = SOBI_PATH.DS.'lib'.DS.'base'.DS.'fs'.DS.'loader.php';
			if(file_exists($file_config)){
				require_once($file_config);
				SPLoader::loadClass( 'base.request' );
				SPLoader::loadClass( 'base.const' );
				SPLoader::loadClass( 'base.factory' );
				SPLoader::loadClass( 'base.object' );
				SPLoader::loadClass( 'sobi' );
				SPLoader::loadClass( 'base.config' );
				SPLoader::loadClass( 'base.exception' );
				SPLoader::loadClass( 'cms.base.lang' );
				SPFactory::config()->set( 'live_site', JURI::root() );
				$sections = array();
				$categories = array();
				$sout = array();
				try {
					$categories = SPFactory::db()
					->select( '*', 'spdb_object', array( 'oType' => 'category' ), 'id' )
					->loadObjectList();
				}
				
				catch ( SPException $x ) {
					trigger_error( 'sobipro|admin_panel|cannot_get_section_list|500|'.$x->getMessage(), SPC::WARNING );
				}
				if( count( $categories ) ) {
						$_categories = array();
						$_children = array();
						foreach ($categories as $i => $category){
							$_categories[$category->id] = &$categories[$i];
						}
						foreach ($categories as $i => $category){
							$cid = $category->id;
							$pid = $category->parent;
							if (isset($_categories[$pid])){
								if (!isset($_children[$pid])){
									$_children[$pid] = array();
								}
								$_children[$pid][$cid] = $cid;
							}
						}
							$__categories = array();
							foreach ($_categories as $cid => $category){
								$pid = $category->parent;
								if ( !isset($_categories[$pid]) ){
									$section_id = $pid;
									$queue = array($cid);
									$_categories[$cid]->level = 1;
									while ( count($queue) > 0 ){
										$qid = array_shift($queue);
										$__categories[$qid] = &$_categories[$qid];
										$__categories[$qid]->section_id =  $section_id;
										if (isset($_children[$qid])){
											foreach ($_children[$qid] as $child){
												$_categories[$child]->level = $_categories[$qid]->level + 1;
												array_push($queue, $child);
											}
										}
									}
								}
							}
							settype($this->value, 'array');
							$select_name = $this->name;
							$select_attr = "";
							if (isset($this->element['multiple'])){
								$select_attr .= " multiple=\"multiple\"";
								$size = $this->element['size'] ?(int) $this->element['size']: 15;
								$select_attr .= " size=\"$size\"";
							}
							
							if (isset($this->element['css'])){
								$select_attr .= ' class="' . trim($this->element['css']) . '"';;
							} else {
								$select_attr .= ' class="inputbox"';;
							}
								$html = "<select $select_attr id=\"" . $this->id . '" name="' . $select_name . '" style="min-width:148px;min-height:14px;">';
								foreach ($__categories as $cid => $category){
										$multiplier = $category->level -1;
										$indent = $multiplier ? str_repeat('- - ', $multiplier) : '';
										$value = $category->id;
										$text  = $indent.$category->name;
										$option = array(
											'label' => $text ,
											'value' => $value
										);
										$selected = in_array($value, $this->value) ? 'selected="selected"' : '';
										$html .= '<option class="section-' .$category->section_id. '"  value="' . $option['value'] . '" ' . $selected . '>' . $option['label'] . '</option>';
								}
								$html .= '</select>';
								$this->addCSjS();
							return $html;
					}
			}else{
				$html[] = "<div style='clear:both; margin: 0 0 0 150px; font-weight:bold; color:red;'>";
				$html[] = JText::_('Sobipro component is not installed?');
				$html[] = "</div>";
				return implode("\n", $html);
			}
		}
		protected function addCSjS(){
			if (version_compare(JVERSION, '3.0.0', '>=')){
				$on_change_application = "
					jQuery(document).ready(function($){
						var in_array = function(needle, haystack){
							try{
								for (var j=0; j<haystack.length; j++){
									if (needle==haystack[j]){
										return true;
									}
								}
							} catch(e){
								return false;
							}
							return false;
						}

						var options = $('#$this->id').find('option');
						var original_section = false;
						var original_categories = [" . implode(',', $this->value) . "];
						
						var showOptions = function(){
							var current_section = $('#jform_params_sid').attr('value');
							if (!original_section){
								original_section = current_section;
							}
							if (typeof current_section != 'undefined'){
								var class_on = 'section-' + parseInt(current_section);
								var currentOptions = [];
							
								for(var i=0; i<options.length; i++){
									if (options[i].hasClass(class_on)){
										$(options[i]).css('display', 'block');
										$(options[i]).attr('disabled', false);
										currentOptions.push($(options[i]));
									} else {
										$(options[i]).css('display', 'none');
										$(options[i]).attr('disabled', 'disabled');
										$(options[i]).removeAttr('selected');
									}
								}
								for(var i=0; i<currentOptions.length; i++){
									if (current_section == original_section){
										var optval = $(currentOptions[i]).attr('value');
										var optsta = $(currentOptions[i]).attr('selected');
										if (!optsta && in_array(optval, original_categories)){
											$(currentOptions[i]).attr('selected', 'selected');
										}
									} else if ( !$('#$this->id').attr('multiple') ){
										$(currentOptions[i]).attr('selected', 'selected');
										break;
									}
								}
							}
							$('#$this->id').trigger('liszt:updated');
						};
						showOptions();
						$('#jform_params_sid').on('change', showOptions);
					});
				";
			} else{
				$on_change_application = "
					window.addEvent('domready', function(){
						var in_array = function(needle, haystack){
							try{
								for (var j=0; j<haystack.length; j++){
									if (needle==haystack[j]){
										return true;
									}
								}
							} catch(e){
								return false;
							}
							return false;
						}
					
						var options = $('$this->id').getElements('option') ;
						var original_section = false;
						var original_categories = [" . implode(',', $this->value) . "];
						
						var showOptions = function(){
							var current_section = this.value;
							if (!original_section){
								original_section = current_section;
							}
							if (typeof current_section != 'undefined'){
								var class_on = 'section-' + parseInt(current_section);
								var currentOptions = new Array();
								
								for(var i=0; i<options.length; i++){
									if (options[i].hasClass(class_on)){
										options[i].setStyle('display', 'block');
										options[i].setProperty('disabled', false);
										currentOptions.push(options[i]);

									} else {
										options[i].setStyle('display', 'none');
										options[i].setProperty('disabled', 'disabled');
									}
								}
								for(var i=0; i<currentOptions.length; i++){
									if (current_section == original_section){
										var optval = currentOptions[i].getProperty('value');
										var optsta = currentOptions[i].getProperty('selected');
										if (!optsta && in_array(optval, original_categories)){
											currentOptions[i].setProperty('selected', 'selected');
										}
									} else if ( !$('$this->id').get('multiple') ){
										currentOptions[i].setProperty('selected', 'selected');
										break;
									}
								}
							}
						};
						$('jform_params_sid').addEvent('change', showOptions);
						$('jform_params_sid').fireEvent('change');
					});
				";
			}
			
			$document = JFactory::getDocument();
			$document->addScriptDeclaration($on_change_application);
			return true;
		}
	}
}