<?php
/**
 * @package SJ Cool Showcase for SobiPro
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2014 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */


defined('_JEXEC') or die;

include_once dirname(__FILE__).'/helper_base.php';
	
class SPCoolShowcaseHelper extends SPCoolShowcaseBaseHelper{
	public static function getList($params){
		/**
		 * Process Section
		 */
		$sid = $params->get('sid',0);
		$objData = SPFactory::object($sid);
		$name = $objData->name;
		$nid = $objData->nid;
		$section = SPFactory::Section($sid);
		if($section->get('state') <= 0) return;
		
		/**
		 * Process Categories
		 */

		$catids = $params->get('catid',0);
		settype($catids,'array');
		if(empty($catids)) return;
		$catids_all = $section->getChilds('category', true, 1);
		if(empty($catids_all)) return;
		$_catids = array();
		foreach($catids as $catid){
			if(in_array($catid,$catids_all)){
				$_catids[] = (int)$catid;
			}
		}
		
		if(empty($_catids)) return;
		$items = self::_getEntry($_catids, $params);
		if(empty($items)) return;
		$list = array();
		$field_description = $params->get('field_description','field_description');
		$field_price = $params->get('field_price','field_price');
		foreach($items as $item){
			$item->_id = $item->get('id');
			$item->title = $item->get('name');
			$item->_author = $item->get( 'metaAuthor' );
			$item->_counter = $item->get( 'counter' );
			$item->_count = $item->get( '_count' );
			$item->_approved = $item->get( 'approved' );
			$item->_textarea = self::_getFieldValues($item, $field_description);
			$item->_description = self::_cleanText($item->_textarea) ;
			$_price = self::_getFieldValues($item, $field_price);
			$item->_price = is_numeric($_price) ? SPLang::currency($_price) : $_price;
			$item->link = $item->url;
			$list[] = $item;
		}
		return $list;
	}
	
	public static function _getEntry($_catids, $params){
		/**
		 * Process Child Category Entries
		 */
		
		if ($params->get('show_child_category_entries', 0) && (int) $params->get('levels', 0) > 0) {
			$levels = $params->get('levels', 1) ? $params->get('levels', 1) : 9999;
			$_catids = self::_getChildrenCategory($_catids,$levels);
		}
		
		/**
		 * Process Entries
		 */
		 
		$eOrder = $params->get('entry_ordering','position.asc');
		$eLimit = $params->get('count',5);
		$eLimit = ($eLimit < 0)?0:$eLimit;
		$entry_ids = array();
		$controller = SPFactory::Controller('section', true);
		!is_array($_catids) && settype($_catids, 'array');
		if(empty($_catids)) return;
		$_items = $controller->getEntries( $eOrder, $eLimit , $eLimStart = 0, $count = false, $conditions = array(),  false, $_catids);
		if(!empty($_items)){
			foreach($_items as $ent_id){
				$entry_ids[] = (int)$ent_id;
			}
		}
		$entry_ids = array_unique($entry_ids);
		if(empty($entry_ids)) return;
		$items = array();
		foreach($entry_ids as $ent_id){
			$entry_model = SPFactory::Model( 'entry' );
			$items[] = $entry_model->init($ent_id);
		}
		
		return $items;
	}

}



