<?php
/**
 * @package SJ Cool Showcase for SobiPro
 * @version 1.0.0
 * @license http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
 * @copyright (c) 2014 YouTech Company. All Rights Reserved.
 * @author YouTech Company http://www.smartaddons.com
 */

defined('_JEXEC') or die;

JHtml::stylesheet('modules/' . $module->module . '/assets/css/style.css');
JHtml::stylesheet('modules/' . $module->module . '/assets/css/style_color.css');
if (!defined('SMART_JQUERY') && (int)$params->get('include_jquery', '1')) {
	JHtml::script('modules/' . $module->module . '/assets/js/jquery-1.8.2.min.js');
	JHtml::script('modules/' . $module->module . '/assets/js/jquery-noconflict.js');
	define('SMART_JQUERY', 1);
}
JHtml::script('modules/' . $module->module . '/assets/js/jquery.procycle.js');
JHtml::script('modules/' . $module->module . '/assets/js/jquery_mousewheel.js');
$tags_id = 'sj_sobipro_cool_showcase_' . rand() . time();
ImageHelper::setDefault($params);
$options = $params->toObject();
?>
<?php if (!empty($list)) {
	?>

	<div class="sj-cool-showcase" id="<?php echo $tags_id; ?>"> <!--Begin sj-cool-showcase-->
		<?php if (!empty($options->pretext)) { ?>
			<div class="pretext">
				<?php echo $options->pretext; ?>
			</div>
		<?php } ?>
		<div class="csc-wap <?php echo $options->theme ?> <?php echo $options->direction_display_when ?>">
			<!--Begin csc-wap-->
			<div class="csc-container"> <!--Begin csc-container-->
				<?php foreach ($list as $item) { ?>
					<div class="csc-item"> <!--Begin csc-item-->
						<div class="csc-item-inner">
							<?php $img = SPCoolShowcaseHelper::getESPImage($item, $params);
							?>
							<img src="<?php echo SPCoolShowcaseHelper::imageSrc($img); ?>"
								 alt="<?php echo $item->title; ?>" title="<?php echo $item->title; ?>"/>
							<?php if ($options->item_border_image == 1) { ?>
								<span class="csc-image-border-small"></span>
								<span class="csc-image-border-large"></span>
							<?php } ?>

							<?php if ($options->item_title_display == 1 || $options->item_desc_display == 1) { ?>
								<div class="csc-content">
									<div class="csc-content-background"></div>
									<div class="csc-content-inner">
										<?php if ($options->item_title_display == 1) { ?>
											<div class="csc-item-title">
												<a href="<?php echo $item->link; ?>"  <?php echo SPCoolShowcaseHelper::parseTarget($options->item_link_target); ?>
												   title="<?php echo $item->title; ?>">
													<?php echo SPCoolShowcaseHelper::truncate($item->title, $options->item_title_max_characs); ?>
												</a>
											</div>
										<?php } ?>
										<?php if ($options->item_desc_display == 1) { ?>
											<div class="csc-item-description">
												<?php echo SPCoolShowcaseHelper::truncate($item->_description, $params->get('item_desc_max_characs')); ?>
											</div>
										<?php } ?>
										<?php if ($params->get('item_price_display') == 1 && isset($item->_price)) { ?>
											<div class="csc-item-price">
												<?php echo $item->_price ; ?>
											</div>
										<?php } ?>
										<?php if ($params->get('item_readmore_display') == 1) { ?>
											<div class="csc-item-readmore">
												<a href="<?php echo $item->link; ?>"  <?php echo SPCoolShowcaseHelper::parseTarget($options->item_link_target); ?>
												   title="<?php echo $item->title; ?>">
													<?php echo $params->get('item_readmore_text', 'Read more'); ?>
												</a>
											</div>
										<?php } ?>
									</div>
								</div>
							<?php } ?>
							<div class="clear"></div>
						</div>
						<div class="clear"></div>
					</div> <!--End csc-container-->
				<?php } ?>
			</div>
			<!--End csc-container-->
			<div class="clear"></div>
		</div>
		<!--End csc-wap-->
		<?php if (!empty($options->posttext)) { ?>
			<div class="pretext" style="width:<?php echo $options->width_module ?>px;">
				<?php echo $options->posttext; ?>
			</div>
		<?php } ?>
	</div> <!--End sj-cool-showcase-->

	<?php
	/*-- css --*/
	ob_start();
	?>
	#<?php echo $tags_id; ?>{
	width:<?php echo $options->width_module; ?>px;

	}
	#<?php echo $tags_id; ?> div.csc-wap{
	width:<?php echo $options->width_module; ?>px;
	height:<?php echo ($options->theme == 'theme1' || $options->theme == 'theme2') ? ($options->imgcfg_height + 88) : ($options->height_module); ?>px;
	}
	<?php if ($options->item_border_image == 1) { ?>

		#<?php echo $tags_id; ?> div.csc-wap div.csc-item.on-top div.csc-item-inner div.csc-content {
		bottom:6px;
		right:6px;
		left:6px;
		display:block;
		}
	<?php } else { ?>
		#<?php echo $tags_id; ?>  .csc-wap .csc-item .csc-item-inner img{
		-webkit-border-radius:0px;
		-moz-border-radius:0px;
		border-radius:0px;
		}
	<?php } ?>
	<?php
	$style_sheet = ob_get_contents();
	@ob_end_clean();
	$document = JFactory::getDocument();
	$document->addStyleDeclaration($style_sheet);
	?>
	<script type="text/javascript">
		//<![CDATA[
		jQuery(document).ready(function ($) {
			;
			(function (element) {
				var $element = $(element);
				$('.csc-wap', $element).procycle({
					nextprev:<?php echo (count($list)<=1)?0:$options->directionNav  ?>,
					numeric:<?php echo (count($list)<=1)?0:$options->buttonNav ?>,
					mouse:<?php echo (count($list)<=1)?0:$options->mouse_wheel ?>,
					slideWidth:<?php echo $options->width_module ?>,
					slideHeight:<?php echo($options->theme=='theme1' || $options->theme=='theme2')?($options->imgcfg_height +45):($options->height_module - 43);?>,
					imageWidth:<?php echo $options->imgcfg_width ?>,
					imageHeight:<?php echo $options->imgcfg_height?>,
					theme: '<?php echo $options->theme ?>',
					distance:<?php echo $options->distance?>,
					slidesPerScroll:<?php echo (count($list)>=$options->slidesPerScroll)?$options->slidesPerScroll:count($list); ?>,
					autoplay:<?php echo $options->autoplay ?>,
					pauseOnHover:<?php echo $options->pauseOnHover ?>,
					autoplayInterval:<?php echo $options->autoplayInterval; ?>,
					speed:<?php echo $options->speed ?>,
					shadow:<?php echo ($options->theme=='theme1' || $options->theme=='theme2')?($options->shadow):0 ;?>,
					style_nextprev: '<?php echo $options->style_directionNav; ?>'
				});
			})('#<?php echo $tags_id ?>');
		});
		//]]>
	</script>

<?php
} else {
	echo JText::_('Has no content to show!');
} ?>
